<?php defined('SYSPATH') or die('No direct script access.');
  
class Model_Teacher_Map extends Model
{
    public function getSemesterInfo($id)
    {
        $sql = "CALL `GetSemesterInfo`('$id'); ";
        return DB::query(Database::SELECT, $sql)->execute()->offsetGet(0);
    } 
	
	public function GetGrades()
    {
        $sql = "CALL `GetGrades`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }  

    public function getMapForDiscipline($teacherID, $disciplineID)
    {
        $sql = "CALL `GetMapForDiscipline`('$teacherID', '$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
    
    public function getStudentsForDiscipline($teacherID, $disciplineID)
    {
        $sql = "CALL `getStudentsForDiscipline`('$teacherID', '$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function AddModuleBonus($teacherID, $disciplineID)
    {
        $sql = "SELECT `AddModuleBonus`('$teacherID', '$disciplineID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function DeleteModuleBonus($teacherID, $disciplineID)
    {
        $sql = "SELECT `DeleteModuleBonus`('$teacherID', '$disciplineID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    } 
	
    public function AddModule($teacherID, $disciplineID, $title)
    {
        $sql = "SELECT `AddModule`('$teacherID', '$disciplineID', '$title') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }    
    
    public function deleteModule($teacherID, $moduleID)
    {
		$sql = "SELECT `DeleteModule`('$teacherID', '$moduleID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function ChangeModuleName($teacherID, $moduleID, $Name)
    {
        $sql = "SELECT `ChangeModuleName`('$teacherID', '$moduleID', '$Name') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function addSubmodule($teacherID, $moduleID, $maxRate, $title, $description, $typeControl)
    {
        $sql = "SELECT `AddSubmodule`('$teacherID', '$moduleID', '$maxRate', '$title', '$description', '$typeControl') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function deleteSubmodule($teacherID, $submoduleID)
    {
        $sql = "SELECT `DeleteSubmodule`('$teacherID', '$submoduleID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function changeSubmoduleName($teacherID, $submoduleID, $Name)
    {
        $sql = "SELECT `ChangeSubmoduleName`('$teacherID', '$submoduleID', '$Name') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    // public function changeModule($teacherID, $moduleID, $order, $title)
    // {
    //     $sql = "SELECT `ChangeModule`('$teacherID', '$moduleID', '$order', '$title') AS `Num`;";
    //     return DB::query(Database::SELECT, $sql)->execute();
    // }
    
    // public function changeSubmodule($teacherID, $submoduleID, $maxRate, $order, $title, $description)
    // {
    //     $sql = "SELECT `ChangeSubmodule`('$teacherID', '$submoduleID', '$maxRate', '$order', '$title', '$description') AS `Num`;";
    //     return DB::query(Database::SELECT, $sql)->execute();
    // }
	
    public function getDisciplineInfoByID($discipline_id)
    {
        $sql = "CALL `GetDisciplineInfoByID`('$discipline_id'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
    
    public function getTeachersForDiscipline($discipline_id)
    {
        $sql = "CALL `GetTeachersForDiscipline`('$discipline_id'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    } 

    public function SwapModuleOrder($teacherID, $moduleID1, $moduleID2)
    {
        $sql = "SELECT `SwapModuleOrder`('$teacherID', '$moduleID1', '$moduleID2') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    // public function SwapSubmoduleOrder($teacherID, $submoduleID1, $submoduleID2)
    // {
    //     $sql = "SELECT `SwapSubmoduleOrder`('$teacherID', '$submoduleID1', '$submoduleID2') AS `Num`;";
    //     return DB::query(Database::SELECT, $sql)->execute();
    // }

    public function ChangeSubmoduleMaxAndControl($teacherID, $SubmoduleID, $MaxRate, $ControlType) 
    {
        $sql = "SELECT `ChangeSubmoduleMaxAndControl`('$teacherID', '$SubmoduleID', '$MaxRate', '$ControlType') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    // public function ChangeSubmoduleMaxRate($teacherID, $SubmoduleID, $MaxRate) //deprecated
    // {
    //     $sql = "SELECT `ChangeSubmoduleMaxRate`('$teacherID', '$SubmoduleID', '$MaxRate') AS `Num`;";
    //     return DB::query(Database::SELECT, $sql)->execute();
    // }
	
    // public function ChangeSubmoduleControlType($teacherID, $SubmoduleID, $ControlType) //deprecated
    // {
    //     $sql = "SELECT `ChangeSubmoduleControlType`('$teacherID', '$SubmoduleID', '$ControlType') AS `Num`;";
    //     return DB::query(Database::SELECT, $sql)->execute();
    // }
	
    public function AddDiscipline($teacherID, $Grade, $SubjectID, $ExamType, $LectionCount, $PracticeCount, $LabCount, $DepartmentID)
    {
        $sql = "SELECT `AddDiscipline`('$teacherID', '$Grade', '$SubjectID', '$ExamType', '$LectionCount', '$PracticeCount', '$LabCount', '$DepartmentID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function ChangeDisciplineSubject($teacherID, $DisciplineID, $SubjectID)
    {
        $sql = "SELECT `ChangeDisciplineSubject`('$teacherID', '$DisciplineID', '$SubjectID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function ChangeDisciplineGrade($teacherID, $DisciplineID, $Grade)
    {
        $sql = "SELECT `ChangeDisciplineGrade`('$teacherID', '$DisciplineID', '$Grade') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function ChangeDisciplineControl($teacherID, $DisciplineID, $Control)
    {
        $sql = "SELECT `ChangeDisciplineControl`('$teacherID', '$DisciplineID', '$Control') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function ChangeDisciplineHours($teacherID, $DisciplineID, $Hours, $Type)
    {
        $sql = "SELECT `ChangeDisciplineHours`('$teacherID', '$DisciplineID', '$Hours', '$Type') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function GetSubjectList($NameFilter, $FacultyID)
    {
        $sql = "CALL `GetSubjects`('$NameFilter','$FacultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function GetFaculties()
    {
        $sql = "CALL `GetFaculties`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function GetDepartments($FacultyID)
    {
        $sql = "CALL `GetDepartments`('$FacultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function GetStudyGroups($Grade, $FacultyID)
    {
        $sql = "CALL `GetStudyGroups`('$Grade', '$FacultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function GetStudyGroupsOrdByGroups($Grade, $FacultyID)
    {
        $sql = "CALL `GetStudyGroupsOrdByGroups`('$Grade', '$FacultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
  //   public function ChangeModuleOrder($teacherID, $moduleID, $OrderNum)
  //   {
		// $sql = "SELECT `ChangeModuleOrder`('$teacherID', '$moduleID', '$OrderNum') AS `Num`;";
		// return DB::query(Database::SELECT, $sql)->execute();
  //   }
	
  //   public function ChangeSubmoduleOrder($teacherID, $SubmoduleID, $OrderNum)
  //   {
		// $sql = "SELECT `ChangeSubmoduleOrder`('$teacherID', '$SubmoduleID', '$OrderNum') AS `Num`;";
		// return DB::query(Database::SELECT, $sql)->execute();
  //   }
	
    public function BindGroup($teacherID, $DisciplineID, $StudyGroupID)
    {
		$sql = "SELECT `BindGroup`('$teacherID', '$DisciplineID', '$StudyGroupID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function UnbindGroup($teacherID, $DisciplineID, $StudyGroupID)
    {
		$sql = "SELECT `UnbindGroup`('$teacherID', '$DisciplineID', '$StudyGroupID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function BindStudent($teacherID, $DisciplineID, $StudentID)
    {
		$sql = "SELECT `BindStudent`('$teacherID', '$DisciplineID', '$StudentID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function UnbindStudent($teacherID, $DisciplineID, $StudentID)
    {
		$sql = "SELECT `UnbindStudent`('$teacherID', '$DisciplineID', '$StudentID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function BindTeacher($AccessedTeacher, $BindingTeacher, $DisciplineID)
    {
		$sql = "SELECT `BindTeacher`('$AccessedTeacher', '$BindingTeacher', '$DisciplineID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }
	
    public function UnbindTeacher($AccessedTeacher, $BindingTeacher, $DisciplineID)
    {
		$sql = "SELECT `UnbindTeacher`('$AccessedTeacher', '$BindingTeacher', '$DisciplineID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }

	public function GetGroupsForDiscipline($DisciplineID)
    {
        $sql = "CALL `GetGroupsForDiscipline`('$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
	public function GetTeachersByFaculty($FacultyID)
    {
        $sql = "CALL `GetTeachersByFaculty`('$FacultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
	public function GetTeachersByDepartment($DepartmentID)
    {
        $sql = "CALL `GetTeachersByDepartment`('$DepartmentID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
	public function SearchStudents($Grade, $GroupN, $FacultyID, $Last, $First, $Second)
    {
        $sql = "CALL `SearchStudents`('$Grade', '$GroupN', '$FacultyID', '$Last', '$First', '$Second'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
	public function SearchStudentsNew($Grade, $GroupN, $FacultyID, $Last, $First, $Second, $DisciplineID)
    {
        $sql = "CALL `SearchStudentsNew`('$Grade', '$GroupN', '$FacultyID', '$Last', '$First', '$Second', '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
	public function getStudentsNotAttendingDiscipline($Grade, $Group, $FacultyID, $Last, $First, $Second, $DisciplineID)
    {
        $sql = "CALL `getStudentsNotAttendingDiscipline`('$Grade', '$Group', '$FacultyID', '$Last', '$First', '$Second', '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	
	public function SearchTeachers($FacultyID, $DepartmentID, $Last, $First, $Second) {
        $sql = "CALL `SearchTeachers`('$FacultyID', '$DepartmentID', '$Last', '$First', '$Second'); ";
        return DB::query(Database::SELECT, $sql)->execute();
	}
	
	public function SearchTeacherNew($FacultyID, $DepartmentID, $Last, $First, $Second, $DisciplineID) {
        $sql = "CALL `SearchTeacherNew`('$FacultyID', '$DepartmentID', '$Last', '$First', '$Second', '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
	}
}
